net.sf.cpsolver.ifs.criteria

## Enum AbstractCriterion.ValueUpdateType

- java.lang.Object
- - java.lang.Enum<AbstractCriterion.ValueUpdateType>
  - - net.sf.cpsolver.ifs.criteria.AbstractCriterion.ValueUpdateType

- All Implemented Interfaces:
    Serializable, Comparable<AbstractCriterion.ValueUpdateType>
  Enclosing class:
    AbstractCriterion<V extends Variable<V,T>,T extends Value<V,T>>

      protected static enum AbstractCriterion.ValueUpdateType
      extends Enum<AbstractCriterion.ValueUpdateType>

  Defines how the overall value of the criterion should be automatically updated (using `Criterion.getValue(Value, Set)`).

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `AfterUnassignedAfterAssigned` Update is done after an unassignment (decrement) and after an assignment (increment).
    `AfterUnassignedBeforeAssigned` Update is done after an unassignment (decrement) and before an assignment (increment).
    `BeforeUnassignedAfterAssigned` Update is done before an unassignment (decrement) and after an assignment (increment).
    `BeforeUnassignedBeforeAssigned` Update is done before an unassignment (decrement) and before an assignment (increment).
    `NoUpdate` Criterion is to be updated manually (e.g., using `Criterion.inc(double)`).

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static AbstractCriterion.ValueUpdateType` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static AbstractCriterion.ValueUpdateType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### BeforeUnassignedBeforeAssigned

          public static final AbstractCriterion.ValueUpdateType BeforeUnassignedBeforeAssigned

      Update is done before an unassignment (decrement) and before an assignment (increment).

    - #### AfterUnassignedBeforeAssigned

          public static final AbstractCriterion.ValueUpdateType AfterUnassignedBeforeAssigned

      Update is done after an unassignment (decrement) and before an assignment (increment).

    - #### BeforeUnassignedAfterAssigned

          public static final AbstractCriterion.ValueUpdateType BeforeUnassignedAfterAssigned

      Update is done before an unassignment (decrement) and after an assignment (increment).

    - #### AfterUnassignedAfterAssigned

          public static final AbstractCriterion.ValueUpdateType AfterUnassignedAfterAssigned

      Update is done after an unassignment (decrement) and after an assignment (increment). This is the default.

    - #### NoUpdate

          public static final AbstractCriterion.ValueUpdateType NoUpdate

      Criterion is to be updated manually (e.g., using `Criterion.inc(double)`).

  - ### Method Detail

    - #### values

          public static AbstractCriterion.ValueUpdateType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AbstractCriterion.ValueUpdateType c : AbstractCriterion.ValueUpdateType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AbstractCriterion.ValueUpdateType valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null